// サーバ上で実行されるコード
if (Meteor.is_server) {
    // プロセスが開始したら
    Meteor.startup(function () {
        // hello()メソッドの定義を行なっている
        Meteor.methods({
            hello: function(firstName, lastName) {
                console.log(this.is_simulation);
                return "Hello, " + firstName + " " + lastName;
            }
        });
    });
}
// クライアント上で実行されるコード
if (Meteor.is_client) {
    // 初期化が完了したら
    Meteor.startup(function() {
        var firstName = document.getElementById('firstName');
        var lastName = document.getElementById('lastName');
        var button = document.getElementById('button');
        // ボタンをクリックされると、サーバ上のhello()メソッドを呼び出す
        button.addEventListener('click', function() {
            Meteor.call('hello', firstName.value, lastName.value, function(error, result) {
                alert(result);
            });
        }, false);
    });
}

